diff --git a/drivers/platform/x86/Kconfig b/drivers/platform/x86/Kconfig
index fe142af..d6925ad 100644
--- a/drivers/platform/x86/Kconfig
+++ b/drivers/platform/x86/Kconfig
@@ -446,6 +446,7 @@ config MSI_WMI
 	tristate "MSI WMI extras"
 	depends on ACPI_WMI
 	depends on INPUT
+	select INPUT_SPARSEKMAP
 	---help---
 	 Say Y here if you want to support WMI-based hotkeys on MSI all-in-one
 	 WindTop AE1900-WT.
diff --git a/drivers/platform/x86/msi-wmi.c b/drivers/platform/x86/msi-wmi.c
index fb6d5bd..5dcb6fb 100644
--- a/drivers/platform/x86/msi-wmi.c
+++ b/drivers/platform/x86/msi-wmi.c
@@ -1,6 +1,7 @@
 /*
  * MSI WMI hotkeys
  *
+ * Copyright (C) 2009 Anisse Astier <anisse@astier.eu>
  * Copyright (C) 2009 JÃ©rÃ´me Pouiller <jezz@sysmic.org>
  *
  * Portions based on hp-wmi.c:
@@ -28,51 +29,25 @@
 
 #include <linux/kernel.h>
 #include <linux/input.h>
+#include <linux/input/sparse-keymap.h>
 #include <linux/acpi.h>
 #include <linux/jiffies.h>
 
 #define MSIWMI_EVENT_GUID "b6f3eef2-3d2f-49dc-9de3-85bce18c62f2"
 
-struct key_entry {
-	u16 code;
-	u16 keycode;
-};
-
-static struct key_entry msi_wmi_keymap[] = {
+static const struct key_entry msi_wmi_keymap[] = {
 	/*Brightness keys should be used for a backlight driver*/
-	{208, KEY_BRIGHTNESSUP},
-	{209, KEY_BRIGHTNESSDOWN},
-	{210, KEY_VOLUMEUP},
-	{211, KEY_VOLUMEDOWN},
-	{0}
+	{KE_KEY, 208, {KEY_BRIGHTNESSUP} },
+	{KE_KEY, 209, {KEY_BRIGHTNESSDOWN} },
+	{KE_KEY, 210, {KEY_VOLUMEUP} },
+	{KE_KEY, 211, {KEY_VOLUMEDOWN} },
+	{KE_END, 0}
 };
 
 static struct input_dev *msi_wmi_input_dev;
 static unsigned long long msi_wmi_time_last_press;
 static unsigned pression_timeout = 10;
 
-static struct key_entry *msi_wmi_get_entry_by_scancode(int code)
-{
-	struct key_entry *key;
-
-	for (key = msi_wmi_keymap; key->code; key++)
-		if (code == key->code)
-			return key;
-
-	return NULL;
-}
-
-static struct key_entry *msi_wmi_get_entry_by_keycode(int keycode)
-{
-	struct key_entry *key;
-
-	for (key = msi_wmi_keymap; key->code; key++)
-		if (keycode == key->keycode)
-			return key;
-
-	return NULL;
-}
-
 static void msi_wmi_notify(u32 value, void *context)
 {
 	struct acpi_buffer response = { ACPI_ALLOCATE_BUFFER, NULL };
@@ -94,7 +69,8 @@ static void msi_wmi_notify(u32 value, void *context)
 				"MSI WMI: event correctly received: %llu\n",
 				obj->integer.value);
 		msi_wmi_time_last_press = get_jiffies_64();
-		key = msi_wmi_get_entry_by_scancode(obj->integer.value);
+		key = sparse_keymap_entry_from_scancode(msi_wmi_input_dev,
+				obj->integer.value);
 		input_report_key(msi_wmi_input_dev, key->keycode, 1);
 		input_sync(msi_wmi_input_dev);
 		input_report_key(msi_wmi_input_dev, key->keycode, 0);
@@ -102,42 +78,8 @@ static void msi_wmi_notify(u32 value, void *context)
 	}
 }
 
-static int msi_wmi_getkeycode(struct input_dev *dev, int scancode, int *keycode)
-{
-	struct key_entry *key = msi_wmi_get_entry_by_scancode(scancode);
-
-	if (key && key->code) {
-		*keycode = key->keycode;
-		return 0;
-	}
-
-	return -EINVAL;
-}
-
-static int msi_wmi_setkeycode(struct input_dev *dev, int scancode, int keycode)
-{
-	struct key_entry *key;
-	int old_keycode;
-
-	if (keycode < 0 || keycode > KEY_MAX)
-		return -EINVAL;
-
-	key = msi_wmi_get_entry_by_scancode(scancode);
-	if (key && key->code) {
-		old_keycode = key->keycode;
-		key->keycode = keycode;
-		set_bit(keycode, dev->keybit);
-		if (!msi_wmi_get_entry_by_keycode(old_keycode))
-			clear_bit(old_keycode, dev->keybit);
-		return 0;
-	}
-
-	return -EINVAL;
-}
-
 static int __init msi_wmi_input_setup(void)
 {
-	struct key_entry *key;
 	int err;
 
 	msi_wmi_input_dev = input_allocate_device();
@@ -145,45 +87,48 @@ static int __init msi_wmi_input_setup(void)
 	msi_wmi_input_dev->name = "MSI WMI hotkeys";
 	msi_wmi_input_dev->phys = "wmi/input0";
 	msi_wmi_input_dev->id.bustype = BUS_HOST;
-	msi_wmi_input_dev->getkeycode = msi_wmi_getkeycode;
-	msi_wmi_input_dev->setkeycode = msi_wmi_setkeycode;
 
-	for (key = msi_wmi_keymap; key->code; key++) {
-		set_bit(EV_KEY, msi_wmi_input_dev->evbit);
-		set_bit(key->keycode, msi_wmi_input_dev->keybit);
-	}
+	err = sparse_keymap_setup(msi_wmi_input_dev, msi_wmi_keymap, NULL);
+	if (err)
+		goto err_free_dev;
 
+	err = wmi_install_notify_handler(MSIWMI_EVENT_GUID,
+					 msi_wmi_notify, NULL);
+	if (err) {
+		printk(KERN_ERR
+		       "MSI WMI: Error while installing notify handler\n");
+		goto err_free_keymap;
+	}
 	err = input_register_device(msi_wmi_input_dev);
-
 	if (err)
-		input_free_device(msi_wmi_input_dev);
+		goto err_uninstall_notifier;
+
+	return 0;
+
+err_uninstall_notifier:
+	wmi_remove_notify_handler(MSIWMI_EVENT_GUID);
+err_free_keymap:
+	sparse_keymap_free(msi_wmi_input_dev);
+err_free_dev:
+	input_free_device(msi_wmi_input_dev);
 
 	return err;
 }
 
 static int __init msi_wmi_init(void)
 {
-	int err;
+	int err = 0;
 
 	msi_wmi_time_last_press = get_jiffies_64();
 	if (!wmi_has_guid(MSIWMI_EVENT_GUID)) {
 		printk(KERN_ERR
 		       "This machine doesn't have MSI-hotkeys through WMI\n");
-		goto load_error;
-	}
-	err = wmi_install_notify_handler(MSIWMI_EVENT_GUID,
-					 msi_wmi_notify, NULL);
-	if (err) {
-		printk(KERN_ERR
-		       "MSI WMI: Error while installing notify handler\n");
-		goto load_error;
+		return -ENODEV;
 	}
 
-	msi_wmi_input_setup();
+	err = msi_wmi_input_setup();
 
-	return 0;
-load_error:
-	return -ENODEV;
+	return err;
 }
 
 static void __exit msi_wmi_exit(void)